﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class HoldableObject : MonoBehaviour
{
    public Transform equipPosition;
    public float distance = 10f;
    public GameObject currentObject;
    GameObject objectPosition;

    public float fovAngle = 45;
    public float headheight;

    bool canGrab;
    bool pickedUp = false;

    public SetControls setControls;

    private void Start()
    {
        setControls.GetComponent<SetControls>();
    }

    private void Update()
    {
        setControls.SetOSControls();
        CheckObject();

        if (canGrab)
        {
            if (Input.GetKey(KeyCode.E) || setControls.pickup)
            {
                if(pickedUp == false)
                {
                    PickUp();
                } else if (pickedUp == true)
                {
                    Drop();
                }
            }
        }
    }

    private void CheckObject()
    {
        RaycastHit hit;

        bool isHit = Physics.BoxCast(transform.position, transform.lossyScale / 2, transform.forward, out hit, transform.rotation, distance);

        Debug.DrawRay(transform.position, transform.TransformDirection(Vector3.forward) * distance, Color.green);

        if (isHit && hit.transform.tag == "HoldableObject")
        {
            //Debug.Log(hit.transform.name);
            Debug.DrawLine(transform.position, hit.transform.position, Color.red);

            canGrab = true;
            objectPosition = hit.transform.gameObject;
        }
        else
        {
            canGrab = false;
        }

    }

    //Holdable Object Position
    private void PickUp()
    {
        currentObject = objectPosition;
        currentObject.transform.position = equipPosition.position;
        currentObject.transform.parent = equipPosition;
        currentObject.transform.localEulerAngles = new Vector3(0f, 180f, 0f);
        currentObject.GetComponent<Rigidbody>().isKinematic = true;
        pickedUp = true;
        Debug.Log("I picked it up!");
    }

    //Drop Object
    private void Drop()
    {
        currentObject.transform.parent = null;
        currentObject.GetComponent<Rigidbody>().isKinematic = false;
        objectPosition = null;
        currentObject = null;
        Debug.Log("I dropped it");
        pickedUp = false;
    }
}
