﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class UpdateGooPaintTex : MonoBehaviour
{
    public RenderTexture gooTex;
    public Material brushMaterial;

    public float multiplier = 1;

    private RenderTextureDescriptor desc;

    public Vector2 worldScale = new Vector2(10, 10);
    public Vector2 worldOffset = new Vector2(5, 5);

    private void Start()
    {
        desc = gooTex.descriptor;

        RenderTexture rt = RenderTexture.active;
        RenderTexture.active = gooTex;
        GL.Clear(true, true, Color.clear);
        RenderTexture.active = rt;
    }

    // Update is called once per frame
    void Update()
    {
        Vector2 uv = new Vector2((transform.position.x + worldOffset.x) / worldScale.x, 
                                (transform.position.z + worldOffset.y) / worldScale.y);

        brushMaterial.SetVector("_UV", uv);
        brushMaterial.SetFloat("_Multiplier", multiplier);

        RenderTexture temp = RenderTexture.GetTemporary(desc);
        Graphics.Blit(gooTex, temp, brushMaterial, 0);
        Graphics.Blit(temp, gooTex);
        RenderTexture.ReleaseTemporary(temp);
    }
}
